package testplugin;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.ocl.examples.xtext.completeocl.utilities.CompleteOCLPlugin;
import org.eclipse.ocl.examples.xtext.console.XtextConsolePlugin;
import org.eclipse.ocl.examples.xtext.console.xtfo.EmbeddedXtextEditor;
import org.eclipse.ocl.examples.xtext.essentialocl.ui.model.BaseDocument;
import org.eclipse.ocl.examples.xtext.essentialocl.utilities.EssentialOCLPlugin;
import org.eclipse.ocl.examples.xtext.oclinecore.utilities.OCLinEcorePlugin;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.xtext.ui.editor.embedded.EmbeddedEditor;

import com.google.inject.Injector;

public class OCLDialog extends Dialog {

	protected String result;
	protected Shell shell;
	private SourceViewer textArea;
	private String title;
	private boolean ok;
	private String text;
	private boolean readOnly;
	private EmbeddedXtextEditor editor;
	private EClass eClass;
	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public OCLDialog(Shell parent, int style, String Title, String text, EClass eClass, boolean readOnly) {
		super(parent);
		setText(Title);
		this.text = text;
		this.readOnly = readOnly;
		this.eClass = eClass;
	}

	
	/**
	 * Open the dialog.
	 * @return the result
	 */
	public void open() {
		createContents();
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		//return textArea.getText();
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() {
		shell = new Shell(getParent(), SWT.BORDER | SWT.CLOSE | SWT.PRIMARY_MODAL | SWT.RESIZE);
		shell.setSize(450, 300);
		shell.setText(getText());
		shell.setLayout(new GridLayout(1, false));

		
		
		Injector injector = XtextConsolePlugin.getInstance().getInjector(EssentialOCLPlugin.LANGUAGE_ID);
		editor = new EmbeddedXtextEditor(shell, injector, /*SWT.BORDER |*/ SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
		textArea = editor.getViewer();
		textArea.getControl().setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		Composite buttonComposite = new Composite(shell, SWT.NONE);
		buttonComposite.setLayout(new RowLayout(SWT.HORIZONTAL));
		buttonComposite.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		Button btnOk = new Button(buttonComposite, SWT.NONE);
		btnOk.setText("Ok");
		
		textArea.getTextWidget().setFont(JFaceResources.getFont(JFaceResources.TEXT_FONT));		

		TestPivot tp = new TestPivot();
		getEditorDocument().setContext(tp.getClassifierForContext(), new HashMap<String, EClassifier>());
		getEditorDocument().set(text);
			
		
	}
	
	public boolean isOk() {
		return ok;
	}
	
	public String getValue() {
		return result;
	}
	
	public BaseDocument getEditorDocument() {
		return (BaseDocument) editor.getDocument();
	}	
}
